// =============================================================================================================
// NOW COMES THE REAL IMPLEMENTATION OF CONSTRAINTS AGAINST INSTALLABLEOPTIONS AND INBETWEEN INSTALLABLE OPTIONS
// =============================================================================================================

// the constraints with installable options are somewhat different than normal constraints
// if you set an installable option, the values for the PDCoreData are corrected
// however, if you set an option within PDCoreData, which is constrained with an installable option, the
// installable option should not be set to another value

// ======================================================
// here are the template specializations for IsConstrainedToInstallableOptions()

BEGINSETABLE(Fold)
ONE_NOTSETABLE(Fold, CenterFold, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, CenterFoldIn, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, CenterFoldOut, MultiFolder, None)
ONE_NOTSETABLE(Fold, ZFold1, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, ZFold1, MultiFolder, None)
ONE_NOTSETABLE(Fold, ZFold2, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, ZFold2, MultiFolder, None)
ONE_NOTSETABLE(Fold, LetterFold, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, LetterFoldIn, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, LetterFoldOut, MultiFolder, None)
ONE_NOTSETABLE(Fold, ZigZag, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, ZigZagIn, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, ZigZagOut, MultiFolder, None)
ONE_NOTSETABLE(Fold, DoubleParallel, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, DoubleParallelIn, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, DoubleParallelOut, MultiFolder, None)
ONE_NOTSETABLE(Fold, GateFold, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, GateFoldIn, MultiFolder, None)
ADDCONSTRAINTPPD(PPDFold, GateFoldOut, MultiFolder, None)
ONE_NOTSETABLE(Fold, Stitch, SaddleStitcher, None)
ADDCONSTRAINTPPD(PPDFold, Stitch, SaddleStitcher, None)
ONE_NOTSETABLE(Fold, Trimming, SaddleStitcher, None)
ADDCONSTRAINTPPD(PPDFold, Trimming, SaddleStitcher, None)
ONE_NOTSETABLE(Fold, MultiLetterFold, SaddleStitcher, None)
ADDCONSTRAINTPPD(PPDFold, MultiLetterFoldIn, SaddleStitcher, None)
ADDCONSTRAINTPPD(PPDFold, MultiLetterFoldOut, SaddleStitcher, None)
ONE_NOTSETABLE(Fold, MultiCenterFold, SaddleStitcher, None)
ADDCONSTRAINTPPD(PPDFold, MultiCenterFold, SaddleStitcher, None)
ONE_NOTSETABLE(Fold, MultiCenterFoldTrim, SaddleStitcher, None)
ADDCONSTRAINTPPD(PPDFold, MultiCenterFoldTrim, SaddleStitcher, None)
ALL_NOTSETABLE_2(Fold, SaddleStitcher, None, MultiFolder, None)
ENDSETABLE(Fold)

BEGINSETABLE(FoldDirection)
ALL_NOTSETABLE_2(FoldDirection, SaddleStitcher, None, MultiFolder, None)
ENDSETABLE(FoldDirection)

BEGINSETABLE(MediaTypeAuto)
ONE_NOTSETABLE(MediaTypeAuto, Transparency, PaperSources, None)
ENDSETABLE(MediaTypeAuto)

BEGINSETABLE(MediaWeightAuto)
ONE_NOTSETABLE(MediaWeightAuto, Thick6, PaperSources, None)
ENDSETABLE(MediaWeightAuto)

BEGINSETABLE(InputSlot)
ONE_NOTSETABLE(InputSlot, Tray3, PaperSources, None)
ONE_NOTSETABLE(InputSlot, Tray4, PaperSources, None)
ONE_NOTSETABLE(InputSlot, Tray5, PaperSources, None)
ENDSETABLE(InputSlot)

BEGINSETABLE(Tab1Tray)
ONE_NOTSETABLE(Tab1Tray, Tray3, PaperSources, None)
ONE_NOTSETABLE(Tab1Tray, Tray4, PaperSources, None)
ONE_NOTSETABLE(Tab1Tray, Tray5, PaperSources, None)
ENDSETABLE(Tab1Tray)

BEGINSETABLE(OutputBin)
ONE_NOTSETABLE(OutputBin, StaplerMain, Stapler, None)
ONE_NOTSETABLE(OutputBin, StaplerSub, Stapler, None)
ONE_NOTSETABLE(OutputBin, Stacker1Main, Stacker, None)
ONE_NOTSETABLE(OutputBin, Stacker1Sub, Stacker, None)
ONE_NOTSETABLE(OutputBin, Stacker2Main, Stacker, None)
ONE_NOTSETABLE(OutputBin, Stacker2Sub, Stacker, None)
ONE_NOTSETABLE(OutputBin, StackerAuto, Stacker, None)
ONE_NOTSETABLE(OutputBin, MultiFoldMain, Stapler, FS_503)
ONE_NOTSETABLE(OutputBin, StackerAuto, Stacker, LS_501)
ONE_NOTSETABLE(OutputBin, Stacker2Main, Stacker, LS_501)
ONE_NOTSETABLE(OutputBin, Stacker2Sub, Stacker, LS_501)
ONE_NOTSETABLE(OutputBin, SaddleSub, SaddleStitcher, None)
ONE_NOTSETABLE(OutputBin, PunchFoldSub, MultiFolder, None)
ONE_NOTSETABLE(OutputBin, MultiFoldMain, MultiFolder, None)
ONE_NOTSETABLE(OutputBin, MultiFoldMain, SaddleStitcher, SD_501)
ONE_NOTSETABLE(OutputBin, MultiFoldMain, Stacker, LS_501)
ONE_NOTSETABLE(OutputBin, MultiFoldMain, Stacker, LS_501_502)
ONE_NOTSETABLE(OutputBin, BinderSub, Binder, None)
ONE_NOTSETABLE(OutputBin, BinderMain, Binder, None)
ENDSETABLE(OutputBin)

BEGINSETABLE(HeaderPage)
ONE_NOTSETABLE(HeaderPage, Tray3, PaperSources, None)
ONE_NOTSETABLE(HeaderPage, Tray4, PaperSources, None)
ONE_NOTSETABLE(HeaderPage, Tray5, PaperSources, None)
ENDSETABLE(HeaderPage)

BEGINSETABLE(BackCoverTray)
ONE_NOTSETABLE(BackCoverTray, Tray3, PaperSources, None)
ONE_NOTSETABLE(BackCoverTray, Tray4, PaperSources, None)
ONE_NOTSETABLE(BackCoverTray, Tray5, PaperSources, None)
ONE_NOTSETABLE(BackCoverTray, PITray1, MultiFolder, None)
ONE_NOTSETABLE(BackCoverTray, PITray2, MultiFolder, None)
ENDSETABLE(BackCoverTray)

BEGINSETABLE(PIBackSheets)
ALL_NOTSETABLE(PIBackSheets, MultiFolder, None)
ENDSETABLE(PIBackSheets)

BEGINSETABLE(FrontCoverTray)
ONE_NOTSETABLE(FrontCoverTray, Tray3, PaperSources, None)
ONE_NOTSETABLE(FrontCoverTray, Tray4, PaperSources, None)
ONE_NOTSETABLE(FrontCoverTray, Tray5, PaperSources, None)
ONE_NOTSETABLE(FrontCoverTray, PITray1, MultiFolder, None)
ONE_NOTSETABLE(FrontCoverTray, PITray2, MultiFolder, None)
ENDSETABLE(FrontCoverTray)

BEGINSETABLE(PIFrontSheets)
ALL_NOTSETABLE(PIFrontSheets, MultiFolder, None)
ENDSETABLE(PIFrontSheets)

BEGINSETABLE(Pile)
ALL_NOTSETABLE(Pile, Stacker, None)
ENDSETABLE(Pile)

BEGINSETABLE(Punch)
ONE_NOTSETABLE(Punch, 3holes, MultiFolder, FD_501_4)
ONE_NOTSETABLE(Punch, 4holes, MultiFolder, FD_501_3)
ALL_NOTSETABLE(Punch, MultiFolder, None)
ENDSETABLE(Punch)

BEGINSETABLE(Staple)
ALL_NOTSETABLE(Staple, Stapler, None)
ENDSETABLE(Staple)

BEGINSETABLE(OHP)
ALL_NOTSETABLE(OHP, PaperSources, None)
ALL_NOTSETABLE(OHPTray, PaperSources, None)
ENDSETABLE(OHP)

BEGINSETABLE(PerfectBinding)
ALL_NOTSETABLE(PerfectBinding, Binder, None)
ENDSETABLE(PerfectBinding)

BEGINSETABLE(PerfectBindMode)
ALL_NOTSETABLE(PerfectBindMode, Binder, None)
ENDSETABLE(PerfectBindMode)

BEGINSETABLE(PerfectBindTray)
ONE_NOTSETABLE(PerfectBindTray, Tray3, PaperSources, None)
ONE_NOTSETABLE(PerfectBindTray, Tray4, PaperSources, None)
ONE_NOTSETABLE(PerfectBindTray, Tray5, PaperSources, None)
ONE_NOTSETABLE(PerfectBindTray, PITray1, MultiFolder, None)
ONE_NOTSETABLE(PerfectBindTray, PITray2, MultiFolder, None)
ALL_NOTSETABLE(PerfectBindTray, Binder, None)
ENDSETABLE(PerfectBindTray)

BEGINSETABLE(PerfectBindTrim)
ALL_NOTSETABLE(PerfectBindTrim, Binder, None)
ENDSETABLE(PerfectBindTrim)

BEGINSETABLE(PerfectBindTrimSpine)
ALL_NOTSETABLE(PerfectBindTrimSpine, Binder, None)
ENDSETABLE(PerfectBindTrimSpine)

BEGINSETABLE(PerfectBindDuplex)
ALL_NOTSETABLE(PerfectBindDuplex, Binder, None)
ENDSETABLE(PerfectBindDuplex)

// ======================================================
// unitializing
#undef BEGINSETABLE
#undef ENDSETABLE
#undef ONE_REMOVED
#undef ALL_REMOVED
#undef ONE_NOTSETABLE
#undef ONE_NOTSETABLE_2
#undef ONE_NOTSETABLE_6
#undef ALL_NOTSETABLE
#undef ALL_NOTSETABLE_2
#undef ALL_NOTSETABLE_6
